REM - BEGIN FILE viewprocs.sql
CREATE OR REPLACE PROCEDURE RQCREATE_VIEW_EDIT
(id integer, dataType integer) is
  cid                   integer;
  function_txt varchar2(30);
  create_txt     varchar2(100);
  select_txt     varchar2(100);
  from_txt         varchar2(100);
  where_txt       varchar2(100);
  sql_txt           varchar2(400);
  id_str             varchar2(10);
  user_str         varchar2(50);
BEGIN
  SELECT user INTO user_str FROM dual;
  id_str := TO_CHAR(id);
  IF dataType = 1 THEN
      function_txt := user_str || '.RQ_STR_TO_STRING';
  ELSE
      function_txt := user_str || '.RQ_STR_TO_NUMBER';
  END IF;
  create_txt := 'CREATE VIEW RQATTRVALUESVIEW_' || id_str || ' AS ';
  select_txt := 'SELECT RequirementID, ' || function_txt || '(FieldValue) AS 
FieldValue ';
  from_txt := 'FROM ' || user_str || '.RQUSERDEFINEDFIELDVALUES ';
  where_txt := 'WHERE FieldID = ' || id_str;
  sql_txt := create_txt || select_txt || from_txt || where_txt;
  cid := DBMS_SQL.OPEN_CURSOR;
  DBMS_SQL.PARSE(cid, sql_txt, dbms_sql.v7);
  DBMS_SQL.CLOSE_CURSOR(cid);
END;
/
CREATE OR REPLACE PROCEDURE RQCREATE_VIEW_LIST
(id integer, dataType integer) is
  cid                   integer;
  create_txt     varchar2(100);
  select_txt     varchar2(200);
  where_txt       varchar2(100);
  sql_txt           varchar2(400);
  id_str             varchar2(10);
  user_str         varchar2(50);
BEGIN
  SELECT user INTO user_str FROM dual;
  id_str := TO_CHAR(id);
  create_txt := 'CREATE VIEW RQATTRVALUESVIEW_' || id_str || ' AS ';
  select_txt := 'SELECT RequirementID, ListItemID, ItemRank FROM ' || user_str 
|| '.RqUserDefinedListValues LV, ' || user_str || '.RqUserDefinedListItems LI 
';
  where_txt := 'WHERE LV.FieldID = LI.FieldID AND ListItemID = ItemID AND 
LV.FieldID = ' || id_str;
  sql_txt := create_txt || select_txt || where_txt;
  cid := DBMS_SQL.OPEN_CURSOR;
  DBMS_SQL.PARSE(cid, sql_txt, dbms_sql.v7);
  DBMS_SQL.CLOSE_CURSOR(cid);
END;
/
CREATE OR REPLACE PROCEDURE RQCREATE_VIEW_SORT
(id integer, dataType integer) is
  cid                   integer;
  create_txt     varchar2(100);
  select_txt     varchar2(200);
  where_txt       varchar2(200);
  sql_txt           varchar2(500);
  id_str             varchar2(10);
  user_str         varchar2(50);
BEGIN
  SELECT user INTO user_str FROM dual;
  id_str := TO_CHAR(id);
  create_txt := 'CREATE VIEW RQATTRVALUESSORTVIEW_' || id_str || ' AS ';
  select_txt := 'SELECT RequirementID, Min(ListItemID) AS ListItemID, 
Min(ItemRank) AS ItemRank FROM ' || user_str || '.RqUserDefinedListValues LV, ' 
|| user_str || '.RqUserDefinedListItems LI ';
  where_txt := 'WHERE LV.FieldID = LI.FieldID AND ListItemID = ItemID AND 
LV.FieldID = ' || id_str;
  where_txt := where_txt || ' GROUP BY RequirementID';
  sql_txt := create_txt || select_txt || where_txt;
  cid := DBMS_SQL.OPEN_CURSOR;
  DBMS_SQL.PARSE(cid, sql_txt, dbms_sql.v7);
  DBMS_SQL.CLOSE_CURSOR(cid);
END;
/
CREATE OR REPLACE PROCEDURE RQCHECK_VIEW
(id integer, dataType integer) is
  cid           integer;
  sql_txt   varchar2(100);
  v_count   number;
  ignore     integer;
  id_str     varchar2(10);
  view_name varchar2(50);
BEGIN
  id_str := TO_CHAR(id);
  view_name := 'RQATTRVALUESVIEW_' || id_str;
  sql_txt := 'SELECT COUNT(*) FROM USER_VIEWS WHERE VIEW_NAME = :vn';
  cid := DBMS_SQL.OPEN_CURSOR;
  DBMS_SQL.PARSE(cid, sql_txt, dbms_sql.v7);
  DBMS_SQL.BIND_VARIABLE(cid, ':vn', view_name);
  DBMS_SQL.DEFINE_COLUMN(cid, 1, v_count);
  ignore := DBMS_SQL.EXECUTE(cid);
  LOOP
      IF DBMS_SQL.FETCH_ROWS(cid)>0 THEN   -- get column values of the row
          DBMS_SQL.COLUMN_VALUE(cid, 1, v_count);
          IF v_count = 0 THEN
              IF dataType = 0 OR dataType = 10 THEN
                  RQCREATE_VIEW_LIST(id, dataType);
              ELSE
                  RQCREATE_VIEW_EDIT(id, dataType);
              END IF;
          END IF;
      ELSE
          EXIT;
      END IF;
  END LOOP;
  IF dataType = 10 THEN
      RQCHECK_VIEW_SORT(id, dataType);
  END IF;
  COMMIT;
  DBMS_SQL.CLOSE_CURSOR(cid);
END;
/
CREATE OR REPLACE PROCEDURE RQCHECK_VIEW_SORT
(id integer, dataType integer) is
  cid           integer;
  sql_txt   varchar2(100);
  v_count   number;
  ignore     integer;
  id_str     varchar2(10);
  view_name varchar2(50);
BEGIN
  id_str := TO_CHAR(id);
  view_name := 'RQATTRVALUESSORTVIEW_' || id_str;
  sql_txt := 'SELECT COUNT(*) FROM USER_VIEWS WHERE VIEW_NAME = :vn';
  cid := DBMS_SQL.OPEN_CURSOR;
  DBMS_SQL.PARSE(cid, sql_txt, dbms_sql.v7);
  DBMS_SQL.BIND_VARIABLE(cid, ':vn', view_name);
  DBMS_SQL.DEFINE_COLUMN(cid, 1, v_count);
  ignore := DBMS_SQL.EXECUTE(cid);
  LOOP
      IF DBMS_SQL.FETCH_ROWS(cid)>0 THEN   -- get column values of the row
          DBMS_SQL.COLUMN_VALUE(cid, 1, v_count);
          IF v_count = 0 THEN
              RQCREATE_VIEW_SORT(id, dataType);
          END IF;
      ELSE
          EXIT;
      END IF;
  END LOOP;
  COMMIT;
  DBMS_SQL.CLOSE_CURSOR(cid);
END;
/
CREATE OR REPLACE PROCEDURE RQREPAIR_VIEWS
is
  attrId integer;
  dataType integer; 
  CURSOR c1 IS
      SELECT Id, dataType
      FROM RqUserDefinedFields;
BEGIN
  OPEN c1;
  LOOP
      FETCH c1 INTO attrId, dataType;
      EXIT WHEN c1%NOTFOUND;
      RqCheck_View(attrId, dataType);
  END LOOP;
  CLOSE c1;
END;
/
CREATE OR REPLACE PROCEDURE RQDROP_ALL_VIEWS
is
  attrId integer;
  CURSOR c1 IS
      SELECT Id FROM RqUserDefinedFields;
BEGIN
  OPEN c1;
  LOOP
      FETCH c1 INTO attrId;
      EXIT WHEN c1%NOTFOUND;
      RqDrop_View(attrId);
  END LOOP;
  CLOSE c1;
END;
/
REM - END FILE viewprocs.sql

